$regfile = "m32def.dat"                                     'typ procesora
$crystal = 12000000                                         'czstotliwo zegara procesora
$baud = 9600                                                'predko komunikacji z moduem VMUSIC2
'=============================================================Konfiguracje============================================================
Config Int0 = Low Level
Config Int1 = Low Level
'nalerzy koniecznie odznaczy fusebit odpowiedzialny za Jtag
'================================================================Port A===============================================================
Config Porta.0 = Input                                      'suchawki
Config Porta.1 = Output                                     'suchawki
Config Porta.2 = Input                                      'pwr
Config Porta.3 = Input                                      'ch+
Config Porta.4 = Input                                      'ch-
Config Porta.5 = Input                                      'enprawo
Config Porta.6 = Input                                      'enlewo
Config Porta.7 = Input                                      'menu
'================================================================Port B===============================================================
Config Portb.1 = Output                                     'OUT1
Config Portb.2 = Input                                      'int2
Config Portb.3 = Output                                     'nowe oprogramowanie do VMUSIC2=1
Config Portb.4 = Output                                     'OUT3

Config Portb.7 = Output                                     'zasilanie moduu VMUSIC2
Config Portc.4 = Output
Config Portc.7 = Output                                     'OUT2
'================================================================Port D===============================================================
'portd.0 i portd.1 uart sprztowy
Config Portd.2 = Input                                      'rc5
Config Portd.3 = Input                                      'int1
Config Portd.4 = Output                                     'kontur "loud"
Config Portd.5 = Input                                      'error
Config Portd.6 = Output                                     'smute
Config Portd.7 = Output                                     'pwm
'============================================================Stan spoczynkowy=========================================================
Porta.0 = 1 : Porta.1 = 1 : Porta.2 = 1 : Porta.3 = 1 : Porta.4 = 1 : Porta.5 = 1 : Porta.6 = 1 : Porta.7 = 1
Portb.0 = 1 : Portb.1 = 0 : Portb.2 = 1 : Portb.3 = 0 : Portb.4 = 0 : Portc.7 = 0
Portd.3 = 1 : Portd.4 = 0 : Portd.5 = 0 : Portd.6 = 1
'============================================================Wyswietlacz LCD==========================================================
Config Lcd = 16 * 1a
Config Lcdpin = Pin , Db4 = Portc.5 , Db5 = Portc.4 , Db6 = Portc.3 , Db7 = Portc.2 , E = Portc.6 , Rs = Portb.0
'==================================================================RC5================================================================
Config Rc5 = Pind.2 , Timer = 0 , Wait = 2000
'===============================================================Watchdog==============================================================
Config Watchdog = 1024
'==================================================================i2c================================================================
Config Scl = Portc.0
Config Sda = Portc.1
'================================================================Timery===============================================================
Config Timer1 = Timer , Prescale = 1
Config Timer2 = Pwm , Prescale = 1 , Compare Pwm = Clear Up
'==================================================================Uart===============================================================
Config Serialin = Buffered , Size = 100 , Bytematch = 13
'===============================================================Deklaracje============================================================
Declare Sub Serial0charmatch()
Declare Sub Odczytaj_czas
Declare Sub Ustaw_czas
Declare Sub Auto_wlaczanie
Declare Sub Pcf8574_led
Declare Sub Pcf8574_uv
Declare Sub Wyslij_tda8425
Declare Sub Wyslij_tea5767
Declare Sub Odczyt_tea5767
Declare Sub Stantby_tea5767
Declare Sub Wyslij_saa6588
Declare Sub Konfiguracje_a
Declare Sub Kontrola_napiec
Cursor Off

On Int0 Pobr_rc5
On Int1 Odczyt_saa6588
On Timer1 Co5_5ms
'==================================================================Zmienne============================================================
Dim Tryb As Byte , Licznik_czas_timer As Integer , Flaga As Bit , Czas_wysylania As Byte , A As Byte
Dim Power_p As Bit , Pomoc As Byte , Pomoc_2 As Byte , Z_sygnal As Byte , Auto_powrut As Byte , Pomoc_menu As Byte
Dim Menu_licznik As Byte , Minus As Bit , Plus As Bit , Gora As Bit , Dol As Bit , Licznik_off As Byte
Dim Sygnal_p As Word , Sygnal_l As Word , Konfiguracje As Byte
Dim Flaga_cls As Bit , Flaga_kasowania As Bit , Menu As Bit , Flaga_tda8425 As Bit , Flaga_licznik_tuner As Bit
Dim Led As Byte , Pomoc_czas As Word , Zezw_wysw As Bit
Dim Gg As Byte , Mm As Byte , Ss As Byte , Pomoc_ss As Byte , Pomoc_mm As Byte
Dim Godziny As Byte , Minuty As Byte , Sekundy As Byte , Flaga_minuty As Byte , Flaga_ustaw_czas As Bit
Dim S As Byte , M As Byte , H As Byte , Godziny_pomoc As Byte
Dim Godziny_alarmu_on As Byte , Minuty_alarmu_on As Byte , Godziny_alarmu_on_bcd As Byte , Minuty_alarmu_on_bcd As Byte
Dim Godziny_alarmu_off As Byte , Minuty_alarmu_off As Byte , Godziny_alarmu_off_bcd As Byte , Minuty_alarmu_off_bcd As Byte
Dim Flaga_minuty_alarmu As Byte , Godziny_pomoc_alarmu As Byte
Dim O_n As Bit , Of_f As Bit , Bledy As String * 3 , Licznik_napiecia As Byte
Dim M_al As Byte , H_al As Byte
Dim Adres As Byte , Wartosc As Byte
Dim Mute As Bit , Pomoc_mute_on As Byte , Pomoc_mute_off As Byte , Loud As Bit
Dim Sleep_ As Bit , Licznik_sleep As Byte , Czas As Byte , Licznik_czas As Byte
Dim Glos_r As Byte , Glos_l As Byte , Glos As Byte , Balans_p As Byte , Balans_l As Byte , Balans_pomoc As Byte
Dim Balans_l_single As Single , Balans_p_single As Single , Balans_single As Single , Balans_integer As Integer , Balans_int As Integer
Dim Bass As Byte , Bass_integer As Integer , Bass_pomoc As Integer , Redukcja_basu As Byte
Dim Treble As Byte , Treble_integer As Integer , Treble_pomoc As Integer
Dim Vol_integer As Integer , Vol_pomoc As Integer
Dim Funkcje As Byte
Dim Impuls_plus As Bit , Impuls_minus As Bit , Glosnosc As Bit , Stereo As Bit
Dim Address As Byte , Command As Byte , Odebr_kod As Bit
Dim Pomoc_prog As Byte
Dim Licznik_funkcje As Byte , Glosniki As Byte , Czas_tea As Byte
Dim Licznik_mp3_wma As Byte , Flaga_licznik_mp3_wma As Bit
Dim Pll As Single , Fset As Word , Dane As Byte , Prog_1 As Byte , Prog_2 As Byte , Licznik_tuner As Byte , Flaga_tea5767 As Bit
Dim Pll_1 As Single , Pll_2 As Single , Pll_3 As Single , Pll_4 As Single , Pll_5 As Single , Pll_6 As Single
Dim Pll_7 As Single , Pll_8 As Single , Pll_9 As Single
Dim Pll_11 As Single , Pll_22 As Single , Pll_33 As Single , Pll_44 As Single , Pll_55 As Single , Pll_66 As Single
Dim Pll_77 As Single , Pll_88 As Single , Pll_99 As Single
Dim Pll_c As Single , Pll_tea As Single , Tea(5) As Byte , Programowanie As Bit , Flaga_stereo As Bit , Sygnal As Byte
Dim 0_saa As Byte , 1_saa As Byte , 2_saa As Byte , 3_saa As Byte , 4_saa As Byte , 5_saa As Byte , 6_saa As Byte
Dim Rds_d1 As Byte , Rds_d2 As Byte , Rds_wybor As Byte , Rds_pozycja As Byte , Pozycja As Byte , Flaga_ps As Bit
Dim Flaga_zezwolenia As Bit , Flaga_ps_name As Bit , Pomoc_ps_name As String * 8
Dim Ps_namex As String * 2 , Ps_name As String * 8 , Rds_s As Byte , Flaga_pomoc_rds As Bit , Flaga_zezw_mp3 As Bit
Dim Flaga_mp3 As Bit , Cr As Byte , Licznik_mp3 As Byte , Liczba_znakow As Byte , Licznik_shift As Byte
Dim Text As String * 7 , Dane_mp3 As String * 49 , Odczyt As Byte , Licznik_text_mp3 As Byte
Dim Files As String * 16 , Title As String * 49 , Artist As String * 24 , Album As String * 24
Dim Files_pomoc As String * 16 , Title_pomoc As String * 49 , Artist_pomoc As String * 24 , Album_pomoc As String * 24
Dim Text_files As String * 16 , Text_title As String * 49 , Text_artist As String * 24 , Text_album As String * 24
Dim Back_mp3 As Bit , Next_mp3 As Bit , Stop_mp3 As Bit , Start_mp3 As Bit , Pause_mp3 As Bit , Pomoc_start_mp3 As Bit , Mp3 As Byte
Dim Bac_k As Bit , Nex_t As Bit , Random_mp3 As Bit , Repeat_mp3 As Bit , Flaga_mp3_play As Bit , Flaga_text_mp3 As Bit
Dim Next_folder As Bit , Text_mp3 As String * 49 , Text_disk_mp3 As String * 16 , Text_mp3_2 As String * 4
Dim Pomoc_serialin As Byte , Sek_mp3 As Byte , Min_mp3 As Byte , Pomoc_czas_mp3 As Bit
Dim Licznik_pomoc_mp3 As Byte , Licznik_odczytu_mp3 As Byte , Serial_flaga As Byte , Pcf_uv As Byte , Licznik_uv As Byte
Dim Flaga_alarm As Bit , Alarm_on As Bit , Alarm As Bit , Pomoc_pilot As Byte , Mute_tuner As Bit
'===================================================================Stae=============================================================
Const A_ = "A"
Const B_ = "B"
Const P_ = "P"
Const L_ = "L"
Const On_ = "ON"
Const Off_ = "OFF"
Const Pl_ = "+"
Const Mi_ = "-"
Const Stereo_ = "stereo"
Const Mono_ = "mono"
Const Tuner_ = "Tuner"
Const Db_ = "dB"
Const Bass_ = "Bass"
Const Treble_ = "Treble"
Const Balans_ = "Balans"
Const Mhz_ = "MHz"
Const Loud_ = "Loud"
Const Vmusic = "    VMUSIC 2"
'============================================================Wczenie przerwa=======================================================
Enable Interrupts
Enable Timer1
Start Timer1
'===========================================================Ustawienia pocztkowe======================================================
Odebr_kod = 1
Licznik_off = 10
Led = 0
Cr = &H0D
Licznik_mp3 = 0
Echo Off
'==============================================================Odczyt pamieci==========================================================
   Readeeprom Vol_integer , 2
   Readeeprom Glos , 4
   Readeeprom Bass_integer , 6
   Readeeprom Bass , 8
   Readeeprom Redukcja_basu , 49
   Readeeprom Treble_integer , 9
   Readeeprom Treble , 11
   Readeeprom Licznik_funkcje , 12
   Readeeprom Funkcje , 13
   Readeeprom Glosniki , 14
   Readeeprom Pll_1 , 15
   Readeeprom Pll_2 , 19
   Readeeprom Pll_3 , 23
   Readeeprom Pll_4 , 27
   Readeeprom Pll_5 , 31
   Readeeprom Pll_6 , 35
   Readeeprom Pll_7 , 39
   Readeeprom Pll_8 , 43
   Readeeprom Pll_9 , 47
   Readeeprom Balans_integer , 63
   Readeeprom Balans_l , 65
   Readeeprom Balans_p , 66
   Readeeprom Prog_1 , 67
   Readeeprom Prog_2 , 48
   Readeeprom Pll_c , 68
   Readeeprom Z_sygnal , 72
   Readeeprom Konfiguracje , 73
   If Konfiguracje.0 = 1 Then : Power_p = 1 : Else : Power_p = 0 : End If       'odczyt bitu power_
   If Konfiguracje.1 = 1 Then : Flaga_stereo = 1 : Else : Flaga_stereo = 0 : End If       'odczyt bitu flaga_stereo
   If Konfiguracje.2 = 1 Then : Mute_tuner = 1 : Else : Mute_tuner = 0 : End If       'odczyt bitu wyciszenia tunera
   If Konfiguracje.3 = 1 Then : Loud = 1 : Else : Loud = 0 : End If       'odczyt bitu kontur "loud"
   Readeeprom Godziny_alarmu_on , 74
   Readeeprom Minuty_alarmu_on , 75
   Readeeprom Godziny_alarmu_off , 76
   Readeeprom Minuty_alarmu_off , 77
   Readeeprom Pll_11 , 78
   Readeeprom Pll_22 , 82
   Readeeprom Pll_33 , 86
   Readeeprom Pll_44 , 90
   Readeeprom Pll_55 , 94
   Readeeprom Pll_66 , 98
   Readeeprom Pll_77 , 102
   Readeeprom Pll_88 , 106
   Readeeprom Pll_99 , 110
   I2csend 64 , Led                                         'wylij dane do sterownika led
   Wait 2                                                   'czekaj 2s po odczytaniu danych
   Start Watchdog
   Enable Int0
   Enable Interrupts

Do
 If Zezw_wysw = 1 Then                                      'ustawiona flaga zezwolenia co 100ms
  If Pina.2 = 0 Then                                        'sprawdzanie stanu przycisku POWER
     Incr Pomoc
     If Pomoc = 20 And Bledy = "" Then :
        Toggle Power_p
        Call Konfiguracje_a
        Set Flaga_kasowania
        Reset Flaga
     End If                                                 'po przytrzymaniu przycisku wczenie urzadzenia
     If Power_p = 1 Then                                    'tylko wtedy gdy urzdzenie wczone
        If Pomoc = 1 Then : Set Flaga : End If              'wyciszenie po przeczeniu rda sygnau morzna przeczy rda sygnau
     End If
  Else
     Pomoc = 0
     If Flaga = 1 Then : Incr Z_sygnal : Licznik_tuner = 0 : Set Flaga_kasowania : Reset Flaga : End If
  End If

  If Odebr_kod = 1 Then                                     'obsuga pilota zdalnego sterowania
     If Address = 0 Then
        Set Flaga_kasowania                                 'ustaw flag kasowania
        If Command = 12 Then
           Incr Pomoc_pilot                                 'jednorazowe dziaanie przycisku pilota
           If Pomoc_pilot = 1 And Bledy = "" Then
              Toggle Power_p
              Call Konfiguracje_a
           End If                                           'wczanie wyczanie
        End If
        If Power_p = 1 Then                                 'zasilanie waczone
           If Command = 56 Then
              Incr Pomoc_pilot
              If Pomoc_pilot = 1 Then : Incr Z_sygnal : Licznik_tuner = 0 : Pomoc_mute_on = 0 : Pomoc_mute_off = 0 : End If
           End If
           If Command = 16 Then : Plus = 1 : End If         'plus
           If Command = 17 Then : Minus = 1 : End If        'minus
           If Command = 20 Then : Gora = 1 : End If         'gra
           If Command = 21 Then : Dol = 1 : End If          'd
           If Command = 55 Then : Bac_k = 1 : End If        'poprzedni utwr
           If Command = 50 Then : Nex_t = 1 : End If        'nastpny utwr
           If Command = 54 Then                             'odtwaanie pause
              If Pomoc_start_mp3 = 1 Then                   'gdy odtwaanie wczone po naciniciu przycisku wstrzymanie odtwaania
                 Pause_mp3 = 1                              'wstrzymaj odtwaanie
                 Start_mp3 = 0
              Else
                 Licznik_pomoc_mp3 = 0
                 Pause_mp3 = 0
                 Start_mp3 = 1                              'start odtwaania
              End If
           End If
           If Command = 28 Then : Next_folder = 1 : Licznik_pomoc_mp3 = 0 : End If       'nastpny folder
           If Command = 52 Then : Stop_mp3 = 1 : Pause_mp3 = 0 : Licznik_pomoc_mp3 = 0 : End If       'zatrzymanie odtwaania
           If Command = 53 Then : Random_mp3 = 1 : Licznik_pomoc_mp3 = 0 : Pomoc_start_mp3 = 0 : End If       'funkcja random
           If Command = 44 Then : Repeat_mp3 = 1 : Licznik_pomoc_mp3 = 0 : Pomoc_start_mp3 = 0 : End If       'powtaanie jednego utworu
           If Command = 13 Then                             'jednorazowe dziaanie przycisku pilota
              Incr Pomoc_pilot
              If Pomoc_pilot = 1 Then : Toggle Mute : End If       'mute
           End If
           If Command = 38 Then                             'sleep
              Incr Pomoc_pilot                              'jednorazowe dziaanie przycisku pilota
              If Pomoc_pilot = 1 Then
                 Sleep_ = 1
                 Pomoc_mm = 0
                 Auto_powrut = 0
                 If Sleep_ = 1 Then : Incr Licznik_sleep : End If
                 If Licznik_sleep > 6 Then : Licznik_sleep = 0 : End If
              End If
           End If
           If Command = 32 Then                             'menu
              Incr Pomoc_pilot                              'jednorazowe dziaanie przycisku pilota
              If Pomoc_pilot = 1 Then
                 Menu = 1
                 Auto_powrut = 0                            'kasowanie flagi autopowrotu z menu
                 If Menu = 1 Then : Incr Menu_licznik : End If
              End If
           End If
           If Z_sygnal = 2 Or Z_sygnal = 3 Then
              If Command = 14 Then                          'tryb programowania                      'tylko wtedy gdy wybrano tuner
                 Incr Pomoc_pilot                           'jednorazowe dziaanie przycisku pilota
                 If Pomoc_pilot = 1 Then
                    Toggle Programowanie
                    If Programowanie = 1 Then
                       Prog_1 = 0                           'wejdz w case 0 w trybie programowania
                       Prog_2 = 0
                    End If
                 End If
              End If
           End If                                           'programowanie stacji radiowych
        End If
           If Command = 15 Then
              Incr Pomoc_pilot                              'jednorazowe dziaanie przycisku pilota
              If Pomoc_pilot = 1 Then
                 Toggle Alarm
                 If Alarm = 1 Then : Set Alarm_on : End If
                 Auto_powrut = 0
              End If
           End If                                           'autmatyczne wczenie
     Else
        Pomoc_pilot = 0                                     'kasowanie zmiennej jednorazowego dziaania przyciskw
     End If
     Reset Odebr_kod
     Enable Int0
  End If

  Call Odczytaj_czas                                        'odczyt aktualnej godziny
  Call Auto_wlaczanie
  If O_n = 1 Then : Set Power_p : Set Flaga_kasowania : Set Flaga_mp3_play : Reset O_n : End If       'auto waczanie ustaw flag auto odtwaania mp3
  If Of_f = 1 Then : Reset Power_p : Set Flaga_kasowania : Reset Of_f : End If       'auto_wczanie

  If Czas > 0 Or Alarm = 1 Then                             'obsuga funkcji sleep
     If Czas > 0 Then                                       'wieci gdy jest wczone auto wczanie
        Toggle Led.2                                        'migaj gdy sleep waczony
     Else
        Led.2 = 1                                           'i automatycznego wczania
     End If
  Else
     Led.2 = 0
  End If

  If Flaga_stereo = 1 Then
     If Stereo = 1 Then                                     'lampka stereo tunera
        Led.3 = 1
     Else
        Led.3 = 0
     End If
  Else
     Led.3 = 0
  End If
  Call Pcf8574_uv                                           'przelij dane o poziomie sygnau do ukadu pcf8574

  If Power_p = 0 Then                                       'tryb czuwania

     Disable Int1                                           'zablokowane przerwane od rds
     Disable Urxc
     Enable Interrupts
     Clear Serialin                                         'kasowanie bufora wejciowego
     Licznik_czas = 0 : Czas = 0 : Czas_wysylania = 0 : Stereo = 0 : Czas_tea = 0 : Pomoc_mute_on = 0 : Pomoc_mute_off = 20       ' ustaw flagi aby po wczeniu prezasa dane
     Licznik_tuner = 0 : Licznik_mp3_wma = 0 : Pomoc_start_mp3 = 0
     Set Flaga_kasowania
     Reset Alarm_on                                         'kasuj flag aby nie wywietla komunikatu po wczeniu
     Compare2 = 150                                         'intensywno podwietlenia
     Portd.6 = 1                                            'wyciszenie kocwek mocy
     Porta.1 = 0                                            'wyciszenie wzmacniacza suchawkowego
     Portd.4 = 0                                            'kontur "loud" wyczony
     Portb.7 = 1                                            'wYczenie moduu VMUSIC2
     Incr Licznik_off
     If Licznik_off > 10 Then : Licznik_off = 10 : Led.4 = 0 : Led.0 = 0 : Led.1 = 0 : End If       'wyaczenie gonikw i zapalenie led czerwony
     Call Pcf8574_led                                       'komunikacja z ukadem pcf8574
     Call Stantby_tea5767                                   'modu radiowy w trybie stantby
     Sygnal = 0                                             'wyga ledy sygnau
     Call Pcf8574_uv                                        'przelij dane do ukadu pcf8574
     If Bledy = "" Then                                     'gdy nie ma bdw wywietlaj godzin
        If Flaga_cls = 1 Then                               'zezwolenie na kasowanie wyswietlacza
           Cls
           Lcd Spc(4) ; Bcd(gg) ; ":" ; Bcd(mm) ; ":" ; Bcd(ss);       'wywietl godzin
           Reset Flaga_cls                                  'kasowanie flagi
        End If
     Else                                                   'gdy jest jaki bd
        If Flaga_kasowania = 1 Then
           Cls
           Lcd Spc(6) ; Bledy;
           Reset Flaga_kasowania
        End If
     End If
  Else

    Licznik_off = 0
    Compare2 = 255                                          'intensywno podwietlenia
    Led.4 = 1                                               'led zielony
    If Loud = 1 Then : Portd.4 = 1 : Else : Portd.4 = 0 : End If       'odczyt flagi loud

    Call Kontrola_napiec                                    'sprawdzaj stan detektorw napi

    If Pina.0 = 0 Then                                      'suchawki odczone
        Pomoc_mute_off = 0
        Incr Pomoc_mute_on
        If Pomoc_mute_on > 20 Then
           Pomoc_mute_on = 20
           Portd.6 = 0                                      'kocwki nie wyciszone
           Porta.1 = 0                                      'wzmacniacz suchawkowy wyciszony
        Else
           Portd.6 = 1                                      'wyciszenie kocwek mocy
           Porta.1 = 0                                      'wzmacniacz suchawkowy wyciszony
        End If                                              'opunienie wyczenia mute
    Else                                                    'suchawki podczone wycisz kocwki mocy i wacz wzmacniacze
        Pomoc_mute_on = 0                                   'suchawkowe
        Incr Pomoc_mute_off
        If Pomoc_mute_off > 20 Then
           Pomoc_mute_off = 20
           Portd.6 = 1                                      'kocwki wyciszone
           Porta.1 = 1                                      'wzmacniacz suchawkowy nie wyciszony
        Else
           Portd.6 = 0                                      'kocwki nie wyciszone
           Porta.1 = 0                                      'wzmacniacz suchawkowy wyciszony
        End If
    End If

    Incr Czas_wysylania                                     'po waczeniu wysyaj dane
    If Czas_wysylania > 10 Then
       Czas_wysylania = 10
    Else
       Set Flaga_kasowania
       Set Flaga_tda8425
       Set Flaga_tea5767
       Call Wyslij_saa6588                                  'wylij dane konfiguracyjne preprocesor rds
    End If                                                  'wysyanie danych po wczeniu

    Select Case Glosniki
      Case 0:
        Led.0 = 0
        Led.1 = 0
      Case 1:
        Led.0 = 1
        Led.1 = 0
      Case 2:
        Led.0 = 0
        Led.1 = 1
      Case 3:
        Led.0 = 1
        Led.1 = 1
    End Select

    If Flaga_licznik_mp3_wma = 1 Then                       'gdy jest wybrany odtwarzacz mp3 ustaw flag pomocnicz
       Incr Licznik_mp3_wma                                 'i zwieksz zawarto licznika
       If Licznik_mp3_wma > 10 Then
          Licznik_mp3_wma = 10
          Set Flaga_kasowania                               'gdy jest nonik danych wykonaj polecenie kasowania
          Reset Flaga_licznik_mp3_wma
       End If
    End If

    If Flaga_mp3 = 1 Then                                   'flaga pomocnicza kasujca tekst wybranej komendy z wywietlacza
       Incr Licznik_pomoc_mp3
       If Licznik_pomoc_mp3 > 5 Then
          Licznik_pomoc_mp3 = 5
          If Pause_mp3 = 0 Then Set Flaga_kasowania         'eby nie kasowa napisu pauza
          Reset Flaga_mp3
          Reset Start_mp3
          Reset Stop_mp3
          Reset Next_mp3
          Reset Back_mp3
          Reset Random_mp3
          Reset Repeat_mp3
          Reset Next_folder
          Mp3 = 0
          Enable Urxc
       Else
          Disable Urxc
       End If
    End If

    If Flaga_licznik_tuner = 1 Then                         'gdy jest wybrany tuner ustaw flag pomocnicz
        Incr Licznik_tuner                                  'i zwikszaj zawarto licznika
        If Licznik_tuner > 10 Then : Licznik_tuner = 10 : Set Flaga_kasowania : Reset Flaga_licznik_tuner : End If
    End If

    If Pina.6 = 0 Then                                      'gdy wcinieta oka impulsatora wejdz do menu po przytrzymaniu
       Incr Pomoc_menu
       If Pomoc_menu = 5 Then : Menu = 1 : Set Flaga_kasowania : End If
       Auto_powrut = 0                                      'kasowanie flagi aby nie wraca gdy jest naciskana oka
       If Menu = 1 Then                                     'gdy flaga menu jest ustawiona
          If Pomoc_menu = 1 Then : Incr Menu_licznik : Set Flaga_kasowania : End If       'i przeanczaj menu po wcisnieciu
       End If
    Else
       If Menu = 1 Then                                     'auto powrt
          Pomoc_menu = 0
          Incr Auto_powrut                                  'auto powrt z menu
          If Auto_powrut > 50 Then : Menu = 0 : Auto_powrut = 0 : Set Flaga_kasowania : End If       'powracaj z menu po czasie
       Else
          If Glosnosc = 1 Or Sleep_ = 1 Or Alarm_on = 1 Then       'sprawdzaj flagi gano ,sleep ,alarm_on , sluchawki_on
             Incr Auto_powrut                               'auto powrt z innych
             If Auto_powrut > 20 Then : Glosnosc = 0 : Sleep_ = 0 : Alarm_on = 0 : Auto_powrut = 0 : Set Flaga_kasowania : End If
          End If
       End If
    End If

    If Menu_licznik > A Then : Menu_licznik = 0 : End If    'licznik menu
    Select Case Menu_licznik
      Case 7:
        If Alarm = 0 Then : Menu_licznik = 9 : Set Flaga_kasowania : End If       'przeskok gdy alarm wyaczony
      Case 8:
        If Alarm = 0 Then : Menu_licznik = 9 : Set Flaga_kasowania : End If       'przeskok gdy alarm wyaczony
    End Select

    Select Case Z_sygnal
     Case 0:
       Disable Int1                                         'zablokowanie przerwana od rds
       Disable Urxc                                         'blokowanie przerwania od bufora wejciowego
       Enable Interrupts                                    'odblokowanie przerwa globalnych
       Czas_tea = 0
       Stereo = 0                                           'led stereo wygaszony
       Sygnal = 0                                           'wyga led sygnau
       Clear Serialin

     Case 1:
       Disable Int1                                         'zablokowanie przerwana od rds
       Disable Urxc                                         'blokowanie przerwania od bufora wejciowego
       Enable Interrupts                                    'odblokowanie przerwa globalnych
       Czas_tea = 0
       Stereo = 0                                           'led stereo wygaszony
       Sygnal = 0                                           'wyga led sygnau
       Clear Serialin

     Case 2:                                                'ustawienia czstotliwoci
      If Menu = 0 Then                                      'przestawija gdy menu wyczone
         If Flaga_pomoc_rds = 1 And Sygnal =< 128 Then      'gdy jest saby sygna kasuj wywietlacz aby wywietli czstotliwo
            Set Flaga_kasowania
            Reset Flaga_pomoc_rds
         End If
       If Programowanie = 1 Then                            'tryb programowania wczony
          If Pina.3 = 0 Or Gora = 1 Then                    'czstotliwo w gr
             Prog_1 = 0                                     'kasowanie liczby programu
             Set Flaga_kasowania
             Pll_c = Pll_c + 0.1
             If Pll_c > 108 Then Pll_c = 88
             Set Flaga_tea5767                              'zapisz numer programu do pamieci
          End If

          If Pina.4 = 0 Or Dol = 1 Then                     'czstotliwo w d
             Prog_1 = 0                                     'kasowanie liczby programu
             Set Flaga_kasowania
             Pll_c = Pll_c - 0.1
             If Pll_c < 88 Then Pll_c = 108
             Set Flaga_tea5767                              'zapisz numer programu do pamieci
          End If

          If Pina.3 = 1 And Pina.4 = 1 And Gora = 0 And Dol = 0 Then
             If Command < 10 Then : Prog_1 = Command : End If       'po wybraniu klawisza numerycznego
          End If
       Else                                                 'tryb programowania wyczony
          If Pina.3 = 0 Or Gora = 1 Then
             Incr Pomoc_prog
             If Pomoc_prog = 1 Then
                Set Flaga_kasowania
                Incr Prog_1
                If Prog_1 > 9 Then Prog_1 = 9
                Set Flaga_tea5767                           'zapisz numer programu do pamieci
             End If
          End If

          If Pina.4 = 0 Or Dol = 1 Then
             Incr Pomoc_prog
             If Pomoc_prog = 1 Then
                Set Flaga_kasowania
                Decr Prog_1
                If Prog_1 < 1 Then Prog_1 = 1
                Set Flaga_tea5767                           'zapisz numer programu do pamieci
             End If
          End If

          If Pina.3 = 1 And Pina.4 = 1 And Gora = 0 And Dol = 0 Then
             Pomoc_prog = 0
             If Command < 10 Then : Prog_1 = Command : End If       'po wybraniu klawisza numerycznego
          End If
       End If
                                              'przecz program radiowy
      End If
      Disable Urxc                                          'blokowanie przerwania od bufora wejciowego
      Clear Serialin
      Incr Czas_tea
      If Czas_tea > 10 Then : Call Wyslij_tea5767 : Call Odczyt_tea5767 : Czas_tea = 0 : End If       'wyslij dane co 1s do moduu radiowego gdy zasilanie wczone

     Case 3:                                                'ustawienia czstotliwoci
      If Menu = 0 Then                                      'przestawija gdy menu wyczone
         If Flaga_pomoc_rds = 1 And Sygnal =< 128 Then      'gdy jest saby sygna kasuj wywietlacz aby wywietli czstotliwo
            Set Flaga_kasowania
            Reset Flaga_pomoc_rds
         End If
       If Programowanie = 1 Then                            'tryb programowania wczony
          If Pina.3 = 0 Or Gora = 1 Then                    'czstotliwo w gr
             Prog_2 = 0                                     'kasowanie liczby programu
             Set Flaga_kasowania
             Pll_c = Pll_c + 0.1
             If Pll_c > 108 Then Pll_c = 88
             Set Flaga_tea5767                              'zapisz numer programu do pamieci
          End If

          If Pina.4 = 0 Or Dol = 1 Then                     'czstotliwo w d
             Prog_2 = 0                                     'kasowanie liczby programu
             Set Flaga_kasowania
             Pll_c = Pll_c - 0.1
             If Pll_c < 88 Then Pll_c = 108
             Set Flaga_tea5767                              'zapisz numer programu do pamieci
          End If

          If Pina.3 = 1 And Pina.4 = 1 And Gora = 0 And Dol = 0 Then
             If Command < 10 Then : Prog_1 = Command : End If       'po wybraniu klawisza numerycznego
          End If
       Else                                                 'tryb programowania wyczony
          If Pina.3 = 0 Or Gora = 1 Then
             Incr Pomoc_prog
             If Pomoc_prog = 1 Then
                Set Flaga_kasowania
                Incr Prog_2
                If Prog_2 > 9 Then Prog_2 = 9
                Set Flaga_tea5767                           'zapisz numer programu do pamieci
             End If
          End If

          If Pina.4 = 0 Or Dol = 1 Then
             Incr Pomoc_prog
             If Pomoc_prog = 1 Then
                Set Flaga_kasowania
                Decr Prog_2
                If Prog_2 < 1 Then Prog_2 = 1
                Set Flaga_tea5767                           'zapisz numer programu do pamieci
             End If
          End If

          If Pina.3 = 1 And Pina.4 = 1 And Gora = 0 And Dol = 0 Then
             Pomoc_prog = 0
             If Command < 10 Then : Prog_2 = Command : End If       'po wybraniu klawisza numerycznego
          End If

       End If
                                              'przecz program radiowy
      End If
      Disable Urxc                                          'blokowanie przerwania od bufora wejciowego
      Clear Serialin
      Incr Czas_tea
      If Czas_tea > 10 Then : Call Wyslij_tea5767 : Call Odczyt_tea5767 : Czas_tea = 0 : End If       'wyslij dane co 1s do moduu radiowego gdy zasilanie wczone

     Case 4:
       Disable Int1                                         'zablokowanie przerwana od rds
       Disable Urxc                                         'blokowanie przerwania od bufora wejciowego
       Enable Interrupts                                    'odblokowanie przerwa globalnych
       Czas_tea = 0
       Stereo = 0                                           'led stereo wygaszony
       Sygnal = 0                                           'wyga led sygnau
       Clear Serialin

     Case 5:
       Disable Int1                                         'zablokowanie przerwana od rds
       Enable Urxc                                          'odblokowanie przerwania od bufora wejciowego
       Enable Interrupts                                    'odblokowanie przerwa globalnych
       Czas_tea = 0
       Stereo = 0                                           'led stereo wygaszony
       Sygnal = 0                                           'wyga led sygnau
       If Menu = 0 And Glosnosc = 0 And Sleep_ = 0 And Alarm_on = 0 And Mute = 0 Then

          Incr Pomoc_serialin
          If Pomoc_serialin > 20 Then
             Pomoc_serialin = 0
             Print "" ; Chr(cr);                            'przesyaj puste dane zakoczone znakiem cr
          End If

          If Pina.3 = 0 Or Nex_t = 1 Then                   'nastpny utwr
             Pomoc_serialin = 0                             'zerowanie licznika
             Licznik_pomoc_mp3 = 0
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Set Next_mp3                                   'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vsf" ; Chr(cr) ;        'dane wylij tylko raz
          End If

          If Pina.4 = 0 Or Bac_k = 1 Then                   'poprzedni utwr
             Pomoc_serialin = 0                             'zerowanie licznika
             Licznik_pomoc_mp3 = 0
             Set Flaga_mp3                                  'ustaw flag aby wywieti napis
             Set Back_mp3                                   'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vsb" ; Chr(cr) ;        'dane wylij dwa razu za pierwszym razem wraca na pocztek biecego utworu
             If Mp3 = 2 Then Print "vsb" ; Chr(cr) ;        'za drugim cofa o jeden utwr
          End If

          If Start_mp3 = 1 Then                             'start odtwaanie wszystkich utworw
             Pomoc_serialin = 0                             'zerowanie licznika
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "v3a" ; Chr(cr) ;        'dane wylij tylko raz i skasuj licznik
             Set Pomoc_czas_mp3
          End If

          If Stop_mp3 = 1 Then                              'zatrzymaj odtwaanie
             Pomoc_serialin = 0                             'zerowanie licznika
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vst" ; Chr(cr) ;        'dane wylij tylko raz
             Reset Pomoc_czas_mp3
          End If

          If Pause_mp3 = 1 Then                             'wstrzymaj odtwaanie
             Pomoc_serialin = 0                             'zerowanie licznika
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vp" ; Chr(cr) ;
             Reset Pomoc_czas_mp3
          End If

          If Random_mp3 = 1 Then                            'odtwaanie losowe
             Pomoc_serialin = 0                             'zerowanie licznika
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vrr" ; Chr(cr) ;
             Set Pomoc_czas_mp3
          End If                                            'dane wylij tylko raz

          If Repeat_mp3 = 1 Then                            'powtaanie tylko jednego pliku
             Pomoc_serialin = 0                             'zerowanie licznika
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vra" ; Chr(cr) ;        'dane wylij tylko raz
             Set Pomoc_czas_mp3
          End If

          If Next_folder = 1 Then                           'przewi o jeden katalog do przodu
             Pomoc_serialin = 0                             'zerowanie licznika
             Set Flaga_mp3                                  'ustaw flag aby wywietli napis
             Incr Mp3
             If Mp3 = 1 Then Print "vsd" ; Chr(cr) ;        'dane wylij tylko raz
             Set Pomoc_czas_mp3
          End If

          If Start_mp3 = 0 And Pause_mp3 = 0 And Stop_mp3 = 0 And Next_mp3 = 0 And Back_mp3 = 0 And Random_mp3 = 0 And Repeat_mp3 = 0 And Next_folder = 0 Then
             If Text_disk_mp3 = "" Then                     'sprawdzanie czy jest tekst o noniku danych
                Incr Licznik_text_mp3                       'zwikszaj licznik
                If Licznik_text_mp3 = 138 Then : Text_mp3 = Vmusic : Text_mp3_2 = "" : Set Flaga_kasowania : End If       'gdy woony nonik czy wywietlacz

                If Album <> Album_pomoc Then : Text_album = Album : End If
                Album_pomoc = Album

                If Licznik_text_mp3 = 2 Then                'nazwa albumu
                   If Text_album = "" Then
                      Licznik_text_mp3 = 31
                   Else
                      Text_mp3 = Text_album
                      Text_mp3_2 = ""
                      Set Flaga_kasowania
                   End If
                End If

                If Artist <> Artist_pomoc Then : Text_artist = Artist : End If
                Artist_pomoc = Artist

                If Licznik_text_mp3 = 32 Then               'nazwa artysty
                   If Text_artist = "" Then
                      Licznik_text_mp3 = 61
                   Else
                      Text_mp3 = Text_artist
                      Text_mp3_2 = ""
                      Set Flaga_kasowania
                   End If
                End If

                If Files <> Files_pomoc Then : Text_files = Files : End If
                Files_pomoc = Files

                If Licznik_text_mp3 = 62 Then               'nazwa utworu
                   If Text_files = "" Then
                      Licznik_text_mp3 = 91
                   Else
                      Text_mp3 = Text_files
                      Text_mp3_2 = ""
                      Set Flaga_kasowania
                   End If
                End If


                If Title <> Title_pomoc Then : Text_title = Title : End If
                Title_pomoc = Title

                If Licznik_text_mp3 = 92 Then               'tytu utworu
                   If Text_title = "" Then
                      Licznik_text_mp3 = 122
                   Else
                      Text_mp3 = Text_title
                      Text_mp3_2 = ""
                      Set Flaga_kasowania
                   End If
                End If

                If Licznik_text_mp3 > 121 Then              'instrukcje wykonywana zawsze gdy licznik wikszy od 121
                   If Flaga_zezw_mp3 = 1 Then
                      Set Flaga_kasowania
                      Text_mp3 = Str(min_mp3)
                      Text_mp3 = Format(text_mp3 , "     00")
                      Text_mp3_2 = Str(sek_mp3)
                      Text_mp3_2 = Format(text_mp3_2 , "00")
                      Reset Flaga_zezw_mp3
                   End If
                End If

                If Licznik_text_mp3 > 130 Then Licznik_text_mp3 = 130
             Else
                Incr Licznik_text_mp3
                If Licznik_text_mp3 = 135 Then
                   Text_mp3 = Text_disk_mp3
                   Text_mp3_2 = ""
                   Set Flaga_kasowania
                End If
                If Licznik_text_mp3 > 137 Then Licznik_text_mp3 = 137
             End If
          End If
       End If

    End Select                                              '

    If Menu = 0 Then
     If Minus = 1 Then
       Glosnosc = 1
       Auto_powrut = 0
       Set Flaga_kasowania
       Vol_integer = Vol_integer - 2
       If Vol_integer < -64 Then Vol_integer = -64
     End If

     If Plus = 1 Then
       Glosnosc = 1
       Auto_powrut = 0
       Set Flaga_kasowania
       Vol_integer = Vol_integer + 2
       If Vol_integer > 6 Then Vol_integer = 6
     End If
    End If

      If Glosnosc = 1 Then                                  'flaga wywietlania siy gosu
        If Flaga_kasowania = 1 Then
         Vol_pomoc = Vol_integer / 2
         Glos = Vol_pomoc + 252
          If Vol_integer <= -4 Then Redukcja_basu = 0       'redukcja basu aby unikn przesterowania
          If Vol_integer = -2 Or Vol_integer = 0 Then
             If Bass_integer = 15 Then Redukcja_basu = 1    'gdy bass rwny 15 redukuj o 3db
             If Bass_integer = 12 Then Redukcja_basu = 0    'gdy bass rwny 12 nie redukuj
          End If
          If Vol_integer = 2 Or Vol_integer = 4 Then
             If Bass_integer = 15 Then Redukcja_basu = 2    'gdy bass rwny 15 redukuj o 6db
             If Bass_integer = 12 Then Redukcja_basu = 1    'gdy bass rwny 12 redukcja o 3db
             If Bass_integer = 9 Then Redukcja_basu = 0     'gdy bass rwny 9 nie redukuj
          End If
          If Vol_integer = 6 Then
             If Bass_integer = 15 Then Redukcja_basu = 3    'gdy bass rwny 15 redukuj o 9db
             If Bass_integer = 12 Then Redukcja_basu = 2    'gdy bass rwny 12 redukuj o 6db
             If Bass_integer = 9 Then Redukcja_basu = 1     'gdy bass rwny 9 redukuj o 3db
             If Bass_integer = 6 Then Redukcja_basu = 0     'gdy bass rwny 6 nie redukuj
          End If

         Cls
         Lcd "Volume" ; Spc(3) ; Vol_integer ; Db_;         'sia gosu
          Writeeeprom Redukcja_basu , 49
          Writeeeprom Vol_integer , 2
          Writeeeprom Glos , 4
         Set Flaga_tda8425
         Reset Flaga_kasowania
        End If
      End If                                                'normalne wywietlenie

      If Mute = 1 Then
        If Flaga_kasowania = 1 Then
         Cls
         Lcd ; Spc(6) ; "MUTE"
         Set Flaga_tda8425
         Reset Flaga_kasowania
        End If
      End If

      If Alarm_on = 1 Then                                  'automatyczne waczanie
        If Flaga_kasowania = 1 Then
         Cls
         Lcd ; Spc(4) ; "ALARM ON"
         Reset Sleep_                                       'wyacz funkcj sleep
         Reset Flaga_kasowania
        End If
      End If

      If Sleep_ = 1 Then
        If Flaga_kasowania = 1 Then
           Select Case Licznik_sleep
             Case 0:
                Czas = 0
             Case 1:
                Czas = 15
             Case 2:
                Czas = 30
             Case 3:
                Czas = 45
             Case 4:
                Czas = 60
             Case 5:
                Czas = 75
             Case 6:
                Czas = 90
           End Select
           Cls
           If Czas = 0 Then
              Lcd ; Spc(7) ; Off_;
           Else
              Lcd ; Spc(6) ; Czas ; "min"
           End If
         Reset Alarm
         Reset Flaga_kasowania
        End If
      End If

       If Menu = 0 Then                                     'menu wyczone
         Menu_licznik = A                                   'wpisanie wartoci pocztkowej
         If Flaga_kasowania = 1 Then                        'zezwolenie na kasowanie wyswietlacza
          Writeeeprom Z_sygnal , 72                         'zapisz stan rda sygnau
          Cls
          If Z_sygnal > 5 Then Z_sygnal = 0
          Select Case Z_sygnal                              'instrukcja wyboru rda sygnau
             Case 0:
               Call Stantby_tea5767
               Portb.7 = 1                                  'wycz zasilanie moduu VMUSIC2
               Pomoc_start_mp3 = 0
               If Alarm = 1 Then : A = 8 : Else : A = 6 : End If       'zmienna menu
               Licznik_mp3_wma = 0
               Licznik_tuner = 0
               Lcd Spc(6) ; "AUX1"
               Led.5 = 0                                    'i
               Led.6 = 1                                    'a
               Led.7 = 1                                    'b
               Funkcje.0 = 1                                'aktywne wejcie 2
             Case 1:
               Call Stantby_tea5767
               Portb.7 = 1                                  'wycz zasilanie moduu VMUSIC2
               Pomoc_start_mp3 = 0
               If Alarm = 1 Then : A = 8 : Else : A = 6 : End If       'zmienna menu
               Licznik_mp3_wma = 0
               Licznik_tuner = 0
               Lcd Spc(6) ; "AUX2"
               Led.5 = 0                                    'i
               Led.6 = 0                                    'a
               Led.7 = 1                                    'b
               Funkcje.0 = 1                                'aktywne wejcie 2
             Case 2:
               A = 10                                       'zmienna menu
               Licznik_mp3_wma = 0
               Portb.7 = 1                                  'wycz zasilanie moduu VMUSIC2
               Pomoc_start_mp3 = 0
               Led.5 = 0                                    'i
               Led.6 = 0                                    'a
               Led.7 = 0                                    'b
               Funkcje.0 = 1                                'aktywne wejcie 2
                If Licznik_tuner <> 10 Then
                   Lcd Spc(4) ; "TUNER 1"
                   Set Flaga_licznik_tuner
                Else
                   If Programowanie = 1 Then                'tryb programowania
                      Select Case Prog_1
                         Case 0:
                            Pll = Pll_c
                         Case 1:
                            Pll_1 = Pll_c
                            Writeeeprom Pll_1 , 15
                         Case 2:
                            Pll_2 = Pll_c
                            Writeeeprom Pll_2 , 19
                         Case 3:
                            Pll_3 = Pll_c
                            Writeeeprom Pll_3 , 23
                         Case 4:
                            Pll_4 = Pll_c
                            Writeeeprom Pll_4 , 27
                         Case 5:
                            Pll_5 = Pll_c
                            Writeeeprom Pll_5 , 31
                         Case 6:
                            Pll_6 = Pll_c
                            Writeeeprom Pll_6 , 35
                         Case 7:
                            Pll_7 = Pll_c
                            Writeeeprom Pll_7 , 39
                         Case 8:
                            Pll_8 = Pll_c
                            Writeeeprom Pll_8 , 43
                         Case 9:
                            Pll_9 = Pll_c
                            Writeeeprom Pll_9 , 47
                      End Select
                      Pll = Pll_c                           'przepisz warto do zmiennej moduu radiowego
                      Lcd "P" ; Prog_1 ; Spc(4) ; Fusing(pll_c , "##.#") ; Mhz_ ;
                   Else                                     'programowanie wyczone
                      Select Case Prog_1
                         Case 1:
                            Pll = Pll_1
                         Case 2:
                            Pll = Pll_2
                         Case 3:
                            Pll = Pll_3
                         Case 4:
                            Pll = Pll_4
                         Case 5:
                            Pll = Pll_5
                         Case 6:
                            Pll = Pll_6
                         Case 7:
                            Pll = Pll_7
                         Case 8:
                            Pll = Pll_8
                         Case 9:
                            Pll = Pll_9
                      End Select
                      Lcd Spc(1) ; Prog_1 ; Spc(4) ; Fusing(pll , "##.#") ; Mhz_       'czstotliwo i rds
                   End If
                End If
             Case 3:
               A = 10                                       'zmienna menu
               Licznik_mp3_wma = 0
               Portb.7 = 1                                  'wycz zasilanie moduu VMUSIC2
               Pomoc_start_mp3 = 0
               Led.5 = 0                                    'i
               Led.6 = 0                                    'a
               Led.7 = 0                                    'b
               Funkcje.0 = 1                                'aktywne wejcie 2
                If Licznik_tuner <> 10 Then
                   Lcd Spc(4) ; "TUNER 2"
                   Set Flaga_licznik_tuner
                Else
                   If Programowanie = 1 Then                'tryb programowania
                      Select Case Prog_2
                         Case 0:
                            Pll = Pll_c
                         Case 1:
                            Pll_11 = Pll_c
                            Writeeeprom Pll_11 , 78
                         Case 2:
                            Pll_22 = Pll_c
                            Writeeeprom Pll_22 , 82
                         Case 3:
                            Pll_33 = Pll_c
                            Writeeeprom Pll_33 , 86
                         Case 4:
                            Pll_44 = Pll_c
                            Writeeeprom Pll_44 , 90
                         Case 5:
                            Pll_55 = Pll_c
                            Writeeeprom Pll_55 , 94
                         Case 6:
                            Pll_66 = Pll_c
                            Writeeeprom Pll_66 , 98
                         Case 7:
                            Pll_77 = Pll_c
                            Writeeeprom Pll_77 , 102
                         Case 8:
                            Pll_88 = Pll_c
                            Writeeeprom Pll_88 , 106
                         Case 9:
                            Pll_99 = Pll_c
                            Writeeeprom Pll_99 , 110
                      End Select
                      Pll = Pll_c                           'przepisz warto do zmiennej moduu radiowego
                      Lcd "P" ; Prog_2 ; Spc(4) ; Fusing(pll_c , "##.#") ; Mhz_ ;
                   Else                                     'programowanie wyczone
                      Select Case Prog_2
                         Case 1:
                            Pll = Pll_11
                         Case 2:
                            Pll = Pll_22
                         Case 3:
                            Pll = Pll_33
                         Case 4:
                            Pll = Pll_44
                         Case 5:
                            Pll = Pll_55
                         Case 6:
                            Pll = Pll_66
                         Case 7:
                            Pll = Pll_77
                         Case 8:
                            Pll = Pll_88
                         Case 9:
                            Pll = Pll_99
                      End Select
                      Lcd Spc(1) ; Prog_2 ; Spc(4) ; Fusing(pll , "##.#") ; Mhz_       'czstotliwo i rds
                   End If
                End If
             Case 4:
               Call Stantby_tea5767
               Portb.7 = 1                                  'wycz zasilanie moduu VMUSIC2
               Pomoc_start_mp3 = 0
               If Alarm = 1 Then : A = 8 : Else : A = 6 : End If       'zmienna menu
               Licznik_mp3_wma = 0
               Licznik_tuner = 0
               Lcd Spc(4) ; "MIKROFON"
               Led.5 = 1                                    'i wycza ukad 4052
               Funkcje.0 = 0                                'aktywne wejcie 1
             Case 5:
               Call Stantby_tea5767
               If Alarm = 1 Then : A = 8 : Else : A = 6 : End If       'zmienna menu
               Licznik_tuner = 0
               Led.5 = 0                                    'i
               Led.6 = 1                                    'a
               Led.7 = 0                                    'b
               Funkcje.0 = 1                                'aktywne wejcie 2
                If Licznik_mp3_wma <> 10 Then               'tekst powitalny
                   Licznik_mp3 = 0                          'zerowanie flagi
                   Portb.3 = 0
                   Portb.7 = 0                              'wczenie zasilania moduu VMUSIC2
                    Pomoc_start_mp3 = 0
                   Lcd Spc(4) ; "MP3/WMA"                   'wywietl aktywne urzdzenia
                    Text_mp3 = Vmusic                       'przepisz tekst
                    Text_mp3_2 = ""                         'wyczy zawarto zmiennej tekstowej
                   Reset Pomoc_czas_mp3                     'zatrzymaj odliczanie czasu
                    Sek_mp3 = 0                             'zeruj licznik sekund
                    Min_mp3 = 0                             'zeruj licznik minut
                   If Konfiguracje.4 = 1 Then : Print "v3a" ; Chr(cr) ; : Set Pomoc_czas_mp3 : End If       'automatyczne odtwaanie gdy wyczono zasilanie podczas odtwaania
                   Set Flaga_licznik_mp3_wma
                Else
                   If Start_mp3 = 1 Then : Lcd Spc(6) ; "Play" : Konfiguracje.4 = 1 : Call Konfiguracje_a : Set Pomoc_start_mp3 : End If
                   If Pause_mp3 = 1 Then : Lcd Spc(5) ; "Pause" : Reset Pomoc_start_mp3 : Licznik_pomoc_mp3 = 0 : End If
                   If Stop_mp3 = 1 Then : Lcd Spc(6) ; "Stop" : Konfiguracje.4 = 0 : Call Konfiguracje_a : Reset Pomoc_start_mp3 : End If
                   If Next_mp3 = 1 Then : Lcd Spc(6) ; "Next" : End If
                   If Back_mp3 = 1 Then : Lcd Spc(6) ; "Back" : End If
                   If Random_mp3 = 1 Then : Lcd Spc(5) ; "Random" : End If
                   If Repeat_mp3 = 1 Then : Lcd Spc(5) ; "Repeat" : End If
                   If Next_folder = 1 Then : Lcd Spc(2) ; "Next folder" : End If
                   If Start_mp3 = 0 And Pause_mp3 = 0 And Stop_mp3 = 0 And Next_mp3 = 0 And Back_mp3 = 0 And Random_mp3 = 0 And Repeat_mp3 = 0 And Next_folder = 0 Then
                      Lcd ; Text_mp3 ; ":" ; Text_mp3_2 ;   'wywietlanie tekstu o odtwaanym utwoe
                   End If
                End If
          End Select

           Set Flaga_tda8425                                'wyslij dane do przdwzmacniacza
          Reset Flaga_kasowania
         End If
       Else                                                 'menu wczone
          Select Case Menu_licznik

             Case 0:                                        'bass
               If Minus = 1 Then                            'zwiksz wzmocnienie niskich tonw
                  Auto_powrut = 0                           'kasowanie zmiennej autopowrotu
                  Set Flaga_kasowania
                  Bass_integer = Bass_integer - 3
                  If Bass_integer < -12 Then Bass_integer = -12       'warto minimalna
               End If
               If Plus = 1 Then                             'zmniejsz wzmocnienie niskich tonw
                  Auto_powrut = 0                           'kasowanie zmiennej autopowrotu
                  Set Flaga_kasowania
                  Bass_integer = Bass_integer + 3
                  If Bass_integer > 15 Then Bass_integer = 15       'wartos maksymalna
               End If
                 Bass_pomoc = Bass_integer / 3              'obliczenia wartosci dla ukadu tda8425
                 Bass = Bass_pomoc + 246

               If Flaga_kasowania = 1 Then                  'zezwolenie na kasowanioe wyswietlacza
                 Cls                                        'kasowanie lcd
                 If Bass_integer > 0 Then
                   Lcd ; Bass_ ; Spc(3) ; Pl_ ; Bass_integer ; Db_;
                 Else
                   Lcd ; Bass_ ; Spc(3) ; Bass_integer ; Db_;
                 End If
                  Writeeeprom Bass_integer , 6              'zapis danych w pamieci nieulotnej
                  Writeeeprom Bass , 8
                 Set Flaga_tda8425                          'wyslij dane do tda8425
                 Reset Flaga_kasowania                      'kasuj flag
               End If

             Case 1:                                        'treble
               If Minus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Treble_integer = Treble_integer - 3
                  If Treble_integer < -12 Then Treble_integer = -12
               End If
               If Plus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Treble_integer = Treble_integer + 3
                  If Treble_integer > 12 Then Treble_integer = 12
               End If
                 Treble_pomoc = Treble_integer / 3
                 Treble = Treble_pomoc + 246

               If Flaga_kasowania = 1 Then
                 Cls
                 If Treble_integer > 0 Then
                   Lcd ; Treble_ ; Spc(3) ; Pl_ ; Treble_integer ; Db_;
                 Else
                   Lcd ; Treble_ ; Spc(3) ; Treble_integer ; Db_;
                 End If
                  Writeeeprom Treble_integer , 9
                  Writeeeprom Treble , 11
                 Set Flaga_tda8425
                 Reset Flaga_kasowania
               End If

             Case 2:                                        'balans
               If Minus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Balans_integer = Balans_integer - 1
                  If Balans_integer < -10 Then Balans_integer = -10
               End If

               If Plus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Balans_integer = Balans_integer + 1
                  If Balans_integer > 10 Then Balans_integer = 10
               End If

               If Flaga_kasowania = 1 Then
                 Cls
                  If Balans_integer > 0 Then                'wywietlenie dla balansu lewego kanau
                     Balans_pomoc = Balans_integer
                     Lcd ; Balans_ ; Spc(3) ; L_ ; " " ; Balans_pomoc;
                  End If
                  If Balans_integer < 0 Then                'wyswietlenie dla prawego kanau
                     Balans_pomoc = Abs(balans_integer)     'nie pokazuj znaku minus
                     Lcd ; Balans_ ; Spc(3) ; P_ ; " " ; Balans_pomoc;
                  End If
                  If Balans_integer = 0 Then                'wyswietlenie dla balans wyczony
                     Lcd ; Balans_ ; Spc(4) ; "0"
                  End If
                  Writeeeprom Balans_integer , 63
                 Set Flaga_tda8425
                 Reset Flaga_kasowania
               End If

             Case 3:                                        'kontur "loud"
               If Plus = 1 Or Minus = 1 Then
                  Set Flaga_kasowania
                  Auto_powrut = 0
                  Toggle Loud
                  Pomoc_mute_on = 0                         'wcz wyciszenie na czas przeczania
                  Pomoc_mute_off = 20
               End If

               If Flaga_kasowania = 1 Then
                  Cls
                  If Loud = 1 Then
                     Konfiguracje.3 = 1
                     Lcd Spc(4) ; Loud_ ; Spc(1) ; On_ ;
                  Else
                     Konfiguracje.3 = 0
                     Lcd Spc(4) ; Loud_ ; Spc(1) ; Off_;
                  End If
                  Call Konfiguracje_a
                  Reset Flaga_kasowania
               End If

             Case 4:                                        'funkcje
               If Minus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Licznik_funkcje = Licznik_funkcje + 1
                  If Licznik_funkcje > 3 Then Licznik_funkcje = 3
               End If

               If Plus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Licznik_funkcje = Licznik_funkcje - 1
                  If Licznik_funkcje = 255 Then Licznik_funkcje = 0
               End If

               If Flaga_kasowania = 1 Then
                 Cls
                  Writeeeprom Licznik_funkcje , 12
                  Select Case Licznik_funkcje
                    Case 0:
                      Lcd ; Spc(1) ; "spatial " ; Stereo_;
                      Funkcje.3 = 1
                      Funkcje.4 = 1
                    Case 1:
                      Lcd ; Spc(2) ; "linear " ; Stereo_;
                      Funkcje.3 = 1
                      Funkcje.4 = 0
                    Case 2:
                      Lcd ; Spc(2) ; "pseudo " ; Stereo_;
                      Funkcje.3 = 0
                      Funkcje.4 = 1
                    Case 3:
                      Lcd ; Spc(3) ; "forced " ; Mono_;
                      Funkcje.3 = 0
                      Funkcje.4 = 0
                  End Select
                 Set Flaga_tda8425
                 Reset Flaga_kasowania
               End If

             Case 5:                                        'goniki
               If Plus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Incr Glosniki
                  Pomoc_mute_on = 0                         'wcz wyciszenie na czas przeczania
                  Pomoc_mute_off = 20
                  If Glosniki > 3 Then Glosniki = 3
               End If

               If Minus = 1 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Decr Glosniki
                  Pomoc_mute_on = 0                         'wcz wyciszenie na czas przeczania
                  Pomoc_mute_off = 20
                  If Glosniki = 255 Then Glosniki = 0
               End If

               If Flaga_kasowania = 1 Then
                 Cls
                  Writeeeprom Glosniki , 14
                  Select Case Glosniki
                    Case 0:
                      Lcd ; Spc(4) ; A_ ; " " ; Mi_ ; " " ; B_ ; " " ; Off_;
                    Case 1:
                      Lcd ; Spc(6) ; A_ ; " " ; On_;
                    Case 2:
                      Lcd ; Spc(6) ; B_ ; " " ; On_;
                    Case 3:
                      Lcd ; Spc(4) ; A_ ; " " ; Pl_ ; " " ; B_ ; " " ; On_;
                  End Select
               Reset Flaga_kasowania
               End If

             Case 6:
               If Pina.3 = 0 Then
                  Set Flaga_kasowania
                  Set Flaga_ustaw_czas
                  Auto_powrut = 0
                  Sekundy = 0
                  Incr Flaga_minuty
                  If Flaga_minuty > 30 Then
                     Incr Godziny_pomoc
                     If Godziny_pomoc > 5 Then
                        Godziny_pomoc = 0
                        Incr Godziny
                        If Godziny > 23 Then Godziny = 0
                     End If
                  Else
                     Incr Minuty
                     If Minuty > 59 Then Minuty = 0
                  End If
               End If

               If Pina.3 = 1 And Pina.4 = 1 Then
                  Flaga_minuty = 0
                  Godziny_pomoc = 0
                  Minuty = Makedec(mm)                      'na posta dziesietn
                  Godziny = Makedec(gg)                     'przepisz do zmiennych ustawienia czasu
               End If

               If Pina.4 = 0 Then
                  Set Flaga_kasowania
                  Set Flaga_ustaw_czas
                  Auto_powrut = 0
                  Sekundy = 0
                  Incr Flaga_minuty
                  If Flaga_minuty > 30 Then
                     Incr Godziny_pomoc
                     If Godziny_pomoc > 5 Then
                        Godziny_pomoc = 0
                        Decr Godziny
                        If Godziny = 255 Then Godziny = 23
                     End If
                  Else
                     Decr Minuty
                     If Minuty = 255 Then Minuty = 59
                  End If
               End If

               If Flaga_cls = 1 Or Flaga_kasowania = 1 Then 'zezwolenie na kasowanie wyswietlacza
                 Cls
                 Lcd Spc(4) ; Bcd(gg) ; ":" ; Bcd(mm) ; ":" ; Bcd(ss);       'wywietl godzin
               Reset Flaga_cls                              'kasowanie flagi
               Reset Flaga_kasowania
               End If

             Case 7:
               If Pina.3 = 0 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Incr Flaga_minuty_alarmu
                  If Flaga_minuty_alarmu > 30 Then
                     Incr Godziny_pomoc_alarmu
                     If Godziny_pomoc_alarmu > 5 Then
                        Godziny_pomoc_alarmu = 0
                        Incr Godziny_alarmu_on
                        If Godziny_alarmu_on > 23 Then Godziny_alarmu_on = 0
                        Writeeeprom Godziny_alarmu_on , 74
                     End If
                  Else
                     Incr Minuty_alarmu_on
                     If Minuty_alarmu_on > 59 Then Minuty_alarmu_on = 0
                     Writeeeprom Minuty_alarmu_on , 75
                  End If
               End If

               If Pina.3 = 1 And Pina.4 = 1 Then
                  Flaga_minuty_alarmu = 0
                  Godziny_pomoc_alarmu = 0
               End If

               If Pina.4 = 0 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Incr Flaga_minuty_alarmu
                  If Flaga_minuty_alarmu > 30 Then
                     Incr Godziny_pomoc_alarmu
                     If Godziny_pomoc_alarmu > 5 Then
                        Godziny_pomoc_alarmu = 0
                        Decr Godziny_alarmu_on
                        If Godziny_alarmu_on = 255 Then Godziny_alarmu_on = 23
                        Writeeeprom Godziny_alarmu_on , 74
                     End If
                  Else
                     Decr Minuty_alarmu_on
                     If Minuty_alarmu_on = 255 Then Minuty_alarmu_on = 59
                     Writeeeprom Minuty_alarmu_on , 75
                  End If
               End If

               If Flaga_kasowania = 1 Then                  'zezwolenie na kasowanie wyswietlacza
                 Cls
                 Lcd " ON " ; Bcd(godziny_alarmu_on_bcd) ; ":" ; Bcd(minuty_alarmu_on_bcd) ; ":00"       'wywietl godzin
               Reset Flaga_kasowania
               End If

             Case 8:
               If Pina.3 = 0 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Incr Flaga_minuty_alarmu
                  If Flaga_minuty_alarmu > 30 Then
                     Incr Godziny_pomoc_alarmu
                     If Godziny_pomoc_alarmu > 5 Then
                        Godziny_pomoc_alarmu = 0
                        Incr Godziny_alarmu_off
                        If Godziny_alarmu_off > 23 Then Godziny_alarmu_off = 0
                        Writeeeprom Godziny_alarmu_off , 76
                     End If
                  Else
                     Incr Minuty_alarmu_off
                     If Minuty_alarmu_off > 59 Then Minuty_alarmu_off = 0
                     Writeeeprom Minuty_alarmu_off , 77
                  End If
               End If

               If Pina.3 = 1 And Pina.4 = 1 Then
                  Flaga_minuty_alarmu = 0
                  Godziny_pomoc_alarmu = 0
               End If

               If Pina.4 = 0 Then
                  Auto_powrut = 0
                  Set Flaga_kasowania
                  Incr Flaga_minuty_alarmu
                  If Flaga_minuty_alarmu > 30 Then
                     Incr Godziny_pomoc_alarmu
                     If Godziny_pomoc_alarmu > 5 Then
                        Godziny_pomoc_alarmu = 0
                        Decr Godziny_alarmu_off
                        If Godziny_alarmu_off = 255 Then Godziny_alarmu_off = 23
                        Writeeeprom Godziny_alarmu_off , 76
                     End If
                  Else
                     Decr Minuty_alarmu_off
                     If Minuty_alarmu_off = 255 Then Minuty_alarmu_off = 59
                     Writeeeprom Minuty_alarmu_off , 77
                  End If
               End If

               If Flaga_kasowania = 1 Then                  'zezwolenie na kasowanie wyswietlacza
                 Cls
                 Lcd "OFF " ; Bcd(godziny_alarmu_off_bcd) ; ":" ; Bcd(minuty_alarmu_off_bcd) ; ":00"       'wywietl godzin
               Reset Flaga_kasowania
               End If

             Case 9:
               If Plus = 1 Or Minus = 1 Then
                  Licznik_tuner = 0
                  Set Flaga_kasowania                       'kasowanie lcd
                  Auto_powrut = 0
                  Toggle Flaga_stereo
               End If

               If Flaga_kasowania = 1 Then
                  Cls
                  If Flaga_stereo = 1 Then
                     Konfiguracje.1 = 1
                     Lcd Spc(2) ; Tuner_ ; Spc(1) ; Stereo_;
                  Else
                     Konfiguracje.1 = 0
                     Lcd Spc(3) ; Tuner_ ; Spc(1) ; Mono_;
                  End If
                  Call Konfiguracje_a
                  Reset Flaga_kasowania
               End If

             Case 10:
               If Plus = 1 Or Minus = 1 Then
                  Licznik_tuner = 0
                  Set Flaga_kasowania
                  Auto_powrut = 0
                  Toggle Mute_tuner
               End If

               If Flaga_kasowania = 1 Then
                  Cls
                  If Mute_tuner = 1 Then
                     Konfiguracje.2 = 1
                     Lcd Spc(1) ; "Wyciszenie " ; On_ ;
                  Else
                     Konfiguracje.2 = 0
                     Lcd Spc(1) ; "Wyciszenie " ; Off_;
                  End If
                  Call Konfiguracje_a
                  Reset Flaga_kasowania
               End If
             End Select
       End If
      End If

    If Flaga_tda8425 = 1 Then                               'komunikacja z ukadem tda8425 tylko wtedy gdy wprowadzono nowe dane
        If Vol_pomoc > 0 Then : Balans_int = Vol_pomoc + 32 : End If       'dla gono > 0
        If Vol_pomoc = 0 Then : Balans_int = 32 : End If    'dla gono = 0
        If Vol_pomoc < 0 Then : Balans_int = 32 - Vol_pomoc : End If       'dla gono < 0
        If Balans_integer > 0 Then                          'balans lewego kanau
           Balans_l_single = Balans_int / 10
           Balans_l_single = Balans_l_single * Balans_pomoc
           Balans_l = Round(balans_l_single)                'zaokrglaj do liczby cakowitej
        End If
        If Balans_integer < 0 Then                          'balans prawego kanau
           Balans_p_single = Balans_int / 10
           Balans_p_single = Balans_p_single * Balans_pomoc
           Balans_p = Round(balans_p_single)                'zaokraglaj do lczby cakowitej
        End If
        If Balans_integer = 0 Then : Balans_l = 0 : Balans_p = 0 : End If       'balans na 0
        Glos_l = Glos - Balans_l                            'sia gosu
        Glos_r = Glos - Balans_p                            'i balans
        Writeeeprom Balans_l , 65
        Writeeeprom Balans_p , 66
         Funkcje.1 = 1
         Funkcje.2 = 1
         If Mute = 1 Then                                   'mute
            Funkcje.5 = 1                                   'wczone
         Else
            Funkcje.5 = 0                                   'wyaczone
         End If
         Funkcje.6 = 1
         Funkcje.7 = 1
       Writeeeprom Funkcje , 13
       Adres = 0
       Wartosc = Glos_l
       Call Wyslij_tda8425
       Adres = 1
       Wartosc = Glos_r
       Call Wyslij_tda8425
       Adres = 2
       Wartosc = Bass - Redukcja_basu                       'obliczenia redukcja basu aby unikn przesterowania
       Call Wyslij_tda8425
       Adres = 3
       Wartosc = Treble
       Call Wyslij_tda8425
       Adres = 8
       Wartosc = Funkcje
       Call Wyslij_tda8425
       Reset Flaga_tda8425                                  'kasowanie flagi
    End If

    If Flaga_tea5767 = 1 Then
       Czas_tea = 10                                        'wyslij dane natychmiast po zmianie czestotliwoci
       If Programowanie = 1 Then                            'tryb programowania
          Writeeeprom Pll_c , 68                            'zapamietaj czstotliwo w trybie programowania
       Else                                                 'tryb normalny wyboru programu
          Writeeeprom Prog_1 , 67                           'zapisz numer programu do pamieci
          Writeeeprom Prog_2 , 48
       End If
       Reset Flaga_tea5767
    End If

    If Flaga_ustaw_czas = 1 Then                            'ustaw czas gdy flaga jest ustawiona
       Call Ustaw_czas
       Reset Flaga_ustaw_czas
    End If

    Call Pcf8574_led                                        'komunikacja z ukadem pdf8574
    Reset Plus                                              'kasowanie zmiennych bitowych wykonywania polece
    Reset Minus
    Reset Gora
    Reset Dol
    Reset Nex_t
    Reset Bac_k
   Reset Watchdog
   Reset Zezw_wysw                                          'kasowanie flagi zezwolenia
 End If                                                     'zamknicie instrukcji zezwolenia
Loop
End
'=================================================================================================
Sub Serial0charmatch():
   Disable Timer0
   Disable Timer1
   Disable Int0
   Disable Urxc
     Input Dane_mp3
     Reset Watchdog                                         'kasowanie licznika watchdoga
   Text = Mid(dane_mp3 , 1 , 7)
     If Text = "Playing" Then
        Licznik_odczytu_mp3 = 0
        Licznik_text_mp3 = 0
        Pomoc_serialin = 0
        Sek_mp3 = 0                                         'zerowanie licznika sekund
        Min_mp3 = 0                                         'zerowanie licznika minut
        Reset Pomoc_czas_mp3
     Else
        If Licznik_odczytu_mp3 < 6 Then Incr Licznik_odczytu_mp3
     End If
   If Text = "No Disk" Then : Text_disk_mp3 = "    No Device" : Else : Text_disk_mp3 = "" : End If       'sprawdzanie czy jest nonik danych

   Select Case Licznik_odczytu_mp3
      Case 0:
        Files = Mid(dane_mp3 , 8 , 40)                      'nazwa
      Case 2:
        Title = Dane_mp3                                    'nazwa utworu
      Case 3:
        Artist = Dane_mp3                                   'nazwa wykonawcy
      Case 4:
        Album = Dane_mp3                                    'nazwa pyty
      Case 5:
        Set Pomoc_czas_mp3                                  'ustaw flag aby odlicza czas
   End Select
   Enable Urxc
   Enable Int0
   Enable Timer1
   Enable Timer0
End Sub

Sub Odczytaj_czas:
   Disable Int1
   Enable Interrupts
   I2cstart
     I2cwbyte 162
     I2cwbyte 2
   I2cstart
     I2cwbyte 163
     I2crbyte Ss , Ack                                      'odczytane dane w kodzie BCD
     I2crbyte Mm , Ack
     I2crbyte Gg , Nack
   I2cstop

   Ss = Ss And &B01111111                                   'maskowanie
   Mm = Mm And &B01111111
   Gg = Gg And &B00111111
   If Ss <> Pomoc_ss Then
      Set Flaga_cls                                         'sprawdz zmienne aby ustawi flag kasowania lcd
      If Pomoc_czas_mp3 = 1 Then                            'gdy flaga ustawiona odliczaj czas
         Set Flaga_zezw_mp3
         Incr Sek_mp3
         If Sek_mp3 > 59 Then
            Sek_mp3 = 0
            Incr Min_mp3                                    'brak ograniczenie minut
         End If
      End If
   End If
   Pomoc_ss = Ss                                            'przepisz zawarto sekund do zmiennej pomocniczej

   If Czas <> 0 Then                                        'sleep
      If Mm <> Pomoc_mm Then : Incr Licznik_czas : End If
      If Licznik_czas = Czas Then : Power_p = 0 : End If    'wyczenie po czasie
   Else
      Pomoc_mm = 0                                          'kasowanie zmiennej pomocniczej czasy sleep
      Licznik_czas = 0
   End If
   Pomoc_mm = Mm                                            'przepisanie zawartoci minut do zmiennej pomocniczej sleep
End Sub

Sub Auto_wlaczanie:
   Minuty_alarmu_on_bcd = Makebcd(minuty_alarmu_on)
   Minuty_alarmu_off_bcd = Makebcd(minuty_alarmu_off)
   Godziny_alarmu_on_bcd = Makebcd(godziny_alarmu_on)
   Godziny_alarmu_off_bcd = Makebcd(godziny_alarmu_off)
   If Alarm = 1 Then                                        'auto wczanie aktywna
      If Minuty_alarmu_on_bcd = Mm And Godziny_alarmu_on_bcd = Gg And Ss = 0 Then Set O_n       'ustaw flage wczania
      If Minuty_alarmu_off_bcd = Mm And Godziny_alarmu_off_bcd = Gg And Ss = 0 Then Set Of_f       'ustaw flag wyaczania
   Else                                                     'auto wczanie nie aktywna
      Reset O_n
      Reset Of_f
   End If
End Sub

Sub Ustaw_czas:
   S = Makebcd(sekundy)
   M = Makebcd(minuty)
   H = Makebcd(godziny)

   I2cstart
     I2cwbyte 162
     I2cwbyte 0
     I2cwbyte 8
   I2cstop
   I2cstart
     I2cwbyte 162
     I2cwbyte 2
     I2cwbyte S                                             'zapis zmiennych w kodzie BCD
     I2cwbyte M
     I2cwbyte H
   I2cstop
End Sub

Sub Pcf8574_led:
   Disable Int1
   Enable Interrupts
   I2csend 64 , Led
   If Power_p = 1 And Glosnosc = 0 And Mute = 0 And Alarm_on = 0 And Sleep_ = 0 And Menu = 0 And Programowanie = 0 And Czas_wysylania = 10 Then
      Select Case Z_sygnal
         Case 2:
           Enable Int1
         Case 3:
           Enable Int1
      End Select
      Enable Interrupts
   End If
End Sub

Sub Pcf8574_uv:
   Disable Int1
   Enable Interrupts
   If Sygnal = 0 Then Pcf_uv = 255                          'sygna = 0
   If Sygnal = 16 Then Pcf_uv = 254                         'sygna = 1
   If Sygnal = 32 Then Pcf_uv = 254                         'sygna = 2
   If Sygnal = 48 Then Pcf_uv = 252                         'sygna = 3
   If Sygnal = 64 Then Pcf_uv = 252                         'sygna = 4
   If Sygnal = 80 Then Pcf_uv = 248                         'sygna = 5
   If Sygnal = 96 Then Pcf_uv = 248                         'sygna = 6
   If Sygnal = 112 Then Pcf_uv = 240                        'sygnal = 7
   If Sygnal = 128 Then Pcf_uv = 240                        'sygna = 8
   If Sygnal = 144 Then Pcf_uv = 224                        'sygna = 9
   If Sygnal = 160 Then Pcf_uv = 224                        'sygna = 10
   If Sygnal = 176 Then Pcf_uv = 192                        'sygna = 11
   If Sygnal = 192 Then Pcf_uv = 192                        'sygna = 12
   If Sygnal = 208 Then Pcf_uv = 128                        'sygna = 13
   If Sygnal = 224 Then Pcf_uv = 128                        'sygnal = 14
   If Sygnal = 240 Then Pcf_uv = 0                          'sygna = 15
   I2csend 66 , Pcf_uv
End Sub

Sub Wyslij_tda8425:
  Disable Int1
  Enable Interrupts
  I2cstart
  I2cwbyte 130
  I2cwbyte Adres
  I2cwbyte Wartosc
  I2cstop
End Sub

Sub Stantby_tea5767:
  Disable Int1
  Enable Interrupts
  I2cinit
  I2cstart
   I2cwbyte &B11000000                                      'adres nadawczy ukadu tea5767
   I2cwbyte &B00000000
   I2cwbyte &B00000000
   I2cwbyte &B00010000
   I2cwbyte &B01010000                                      'stantby wczone
   I2cwbyte &B00000000
  I2cstop
End Sub

Sub Wyslij_tea5767:
  Disable Int1
  Enable Interrupts
  I2cinit
  I2cstart
  I2cwbyte &B11000000                                       'adres nadawczy ukadu TEA5767
  Pll_tea = Pll * 1000000
  Pll_tea = Pll_tea + 225000
  Pll_tea = Pll_tea * 4
  Pll_tea = Pll_tea / 32768
  Fset = Int(pll_tea)
  Dane = High(fset)
  If Mute_tuner = 1 Then                                    'wyciszenie
     If Sygnal < 80 Then : Set Dane.7 : Else : Reset Dane.7 : End If       'wyciszenie przy sabym sygnale
  Else                                                      'wyciszenie wczone
     Reset Dane.7
  End If
  Reset Dane.6
  I2cwbyte Dane                                             'bajt 1
  Dane = Low(fset)
  I2cwbyte Dane                                             'bajt 2
  If Flaga_stereo = 1 Then                                  'stereo wczone
     I2cwbyte &B00010000                                    'bit 3 odpowiada za wczenie stereo 0 stereo on
  Else                                                      'mono
     I2cwbyte &B00011000
  End If
  I2cwbyte &B00010000                                       'bit 6 stantby 1 on 0 off
  I2cwbyte &B00000000
  I2cstop
End Sub

Sub Odczyt_tea5767:
  Disable Int1
  Enable Interrupts
  I2cinit
  I2cstart
  I2cwbyte &B11000001                                       'adres odbiorczy ukadu tea5767
  I2crbyte Tea(1) , Ack
  I2crbyte Tea(2) , Ack
  I2crbyte Tea(3) , Ack
  I2crbyte Tea(4) , Ack
  I2crbyte Tea(5) , Nack
  I2cstop

  If Tea(3).7 = 1 Then                                      'odczyt flagi stereo
     Stereo = 1
  Else
     Stereo = 0
  End If
  Sygnal = Tea(4) And &B11110000                            'maskowanie do odczytu poziomu sygnau
End Sub

Sub Wyslij_saa6588:
  Disable Int1
  Enable Interrupts
  I2cstart
   I2cwbyte 32
   I2cwbyte 43
   I2cwbyte 0
   I2cwbyte &B01111100
  I2cstop                                                   'resetowanie bitu synchronizacji
End Sub

Sub Konfiguracje_a:
  If Power_p = 1 Then
     Konfiguracje.0 = 1
  Else
     Konfiguracje.0 = 0
  End If
  Writeeeprom Konfiguracje , 73                             'zapisz stan wanych bitw
End Sub

Sub Kontrola_napiec:                                        'procedura wywoywana co obieg pti trwajcy 115ms
  If Pind.5 = 1 Then                                        'sprawdzanie stanu detektorw napicia zasilania
     Incr Licznik_napiecia                                  'gdy jest sygna z detektorw zwikszaj stan licznika
     If Licznik_napiecia > 16 Then : Licznik_napiecia = 16 : Set Flaga_kasowania : Bledy = "F61" : Reset Power_p : End If
  Else                                                      'gdy sygna z detektora utrzymuje si przez 5s wycz wzmacniacz i wywiet komunikat o bdzie
     Licznik_napiecia = 0                                   'gdy nie ma sygnau z detektorw kasuj licznik zmiennej
  End If
End Sub

Pobr_rc5:
  Disable Int0
  Disable Int1
  Disable Urxc
  Enable Interrupts

  Getrc5(address , Command)

  Command = Command And &B0111111
  Set Odebr_kod
Return

Odczyt_saa6588:
  Disable Int1
  Enable Interrupts
  I2cstart
  I2cwbyte 33                                               'adres odczytu ukadu saa6588
   I2crbyte 0_saa , Ack                                     'odczyt danych
   I2crbyte 1_saa , Ack
   I2crbyte 2_saa , Ack
   I2crbyte 3_saa , Ack
   I2crbyte 4_saa , Ack
   I2crbyte 5_saa , Ack
   I2crbyte 6_saa , Nack
  I2cstop
                                                            'przepisanie 16 bitw do zmiennej rds_d1 i rds_d2
  Rds_d1.0 = 1_saa.0
  Rds_d1.1 = 1_saa.1
  Rds_d1.2 = 1_saa.2
  Rds_d1.3 = 1_saa.3
  Rds_d1.4 = 1_saa.4
  Rds_d1.5 = 1_saa.5
  Rds_d1.6 = 1_saa.6
  Rds_d1.7 = 1_saa.7
  Rds_d2.0 = 2_saa.0
  Rds_d2.1 = 2_saa.1
  Rds_d2.2 = 2_saa.2
  Rds_d2.3 = 2_saa.3
  Rds_d2.4 = 2_saa.4
  Rds_d2.5 = 2_saa.5
  Rds_d2.6 = 2_saa.6
  Rds_d2.7 = 2_saa.7

  Rds_wybor.0 = 0_saa.5                                     'przepisanie zawartoci wyboru bloku danych
  Rds_wybor.1 = 0_saa.6
  Rds_wybor.2 = 0_saa.7
  Rds_wybor.3 = 0
  Rds_wybor.4 = 0
  Rds_wybor.5 = 0
  Rds_wybor.6 = 0
  Rds_wybor.7 = 0
'====================================================================bloki=========================================================
  Select Case Rds_wybor
     Case 1:                                                'blok "A"
       Rds_s = 0                                            'ODCZYTANIE ADRESU SEGMTU
       Rds_s.3 = Rds_d1.3
       Rds_s.4 = Rds_d1.4
       Rds_s.5 = Rds_d1.5
       Rds_s.6 = Rds_d1.6
       Rds_s.7 = Rds_d1.7
       Select Case Rds_s
          Case 0:
            Set Flaga_ps
            Rds_pozycja = 0
            Rds_pozycja.0 = Rds_d2.0
            Rds_pozycja.1 = Rds_d2.1
            Select Case Rds_pozycja
              Case 0:
                Pozycja = 1
              Case 1:
                Pozycja = 3
              Case 2:
                Pozycja = 5
              Case 3:
                If Flaga_zezwolenia = 1 Then
                   Set Flaga_ps_name
                End If
                Pozycja = 7
            End Select
       End Select

     Case 3:                                                'blok "C" nazwa stacji
       If Sygnal > 128 And Odebr_kod = 0 Then               'wywietlaj tylko przy dobrym sygnale aby unikn przekamania
          Set Flaga_pomoc_rds                               'ustaw flag pomocnicz
          If Flaga_ps = 1 Then                              'pokazuj komunikaty rds gdy sygna jest na dobrym poziomie
             Ps_namex = Chr(rds_d1) + Chr(rds_d2)
             Mid(ps_name , Pozycja , 2) = Ps_namex
             If Pomoc_ps_name <> Ps_name Then : Flaga_zezwolenia = 1 : Else : Flaga_zezwolenia = 0 : End If
             Pomoc_ps_name = Ps_name
             If Flaga_ps_name = 1 Then
                Cls
                Lcd Spc(4) ; Ps_name
                Reset Flaga_ps_name
             End If
             Reset Flaga_ps
          End If
       End If

     Case 4:
       Reset Flaga_ps
  End Select
  Enable Int1
Return

Co5_5ms:
  Incr Licznik_czas_timer
  If Licznik_czas_timer > 20 Then : Licznik_czas_timer = 0 : Set Zezw_wysw : End If       'zezwolenie wywietlenia
  Select Case Tryb
   Case 0:
    If Pina.5 = 1 And Pina.7 = 1 Then Incr Tryb             'jezeli dwa rozwarte
   Case 1:
    If Pina.5 = 1 And Pina.7 = 0 Then Tryb = 2
    If Pina.5 = 0 And Pina.7 = 1 Then Tryb = 3
   Case 2:
    If Pina.5 = 0 And Pina.7 = 1 Then
      Set Zezw_wysw
      Set Flaga_kasowania
      Set Minus
      Licznik_czas_timer = 0
      Tryb = 0
    End If
   Case 3:
    If Pina.5 = 1 And Pina.7 = 0 Then
      Set Zezw_wysw
      Set Flaga_kasowania
      Set Plus
      Licznik_czas_timer = 0
      Tryb = 0
    End If
  End Select
  Waitus 100
Return
